package FDN::Adsl::Controller::Payant;

use strict;
use warnings;
use base 'FDN::Adsl::Controller::Base';

use FDN::Web::Array;
use FDN::Web::Forms;

use FDN::Adsl::Basic;
use FDN::Adsl::New;
use FDN::Adsl::Utils;

__PACKAGE__->config->{'namespace'} = 'adsl/payant';


sub xnew :Path('new') {
	my ( $self, $c ) = @_;

	my $vars = $c->req->params;
	my $paid = $vars->{'id'};

	my $form = form_payant($vars);
	if ( $vars->{'do'} ne 'yes' ) {
		renseigne_payant($vars,$paid);
		$c->detach('Base','eject_page',[affiche_form($form,$vars)]);
	}
	if ( !check_transition($form,$vars) ) {
		$c->detach('Base','eject_page',[affiche_form($form,$vars)]);
	}
	modifie_payant($vars,$paid);
	my $from = $vars->{'from'};
	$c->detach('Base','back_from', [$from]);
}

sub liste :Local {
	my ( $self, $c ) = @_;

	if ( $c->req->param('client') ) {
		my $cid = $c->req->param('client');
		my $payants = [ payant_par_client_id($cid) ];
		my $page = $self->large_table_2d($c, 'payant', $payants, "Items payants de l'abonn", {
			'Ajouter' => "/adsl/payant/new?client=$cid&from=client$cid"
		});
		$c->detach('Base', 'eject_page', [ $page ] );
	}

	$c->detach('Base','eject_error',["C'est idiot de vouloir lister des payants en vrac"]);
}

sub view :Local {
	my ( $self, $c, $iid ) = @_;

	my $vars = $c->req->params;
	my $page;

	my $form = form_read('adsl/form/view.cfg','vpayant');
	if ( $vars->{'do'} ne 'yes' ) {
		$page = affiche_form($form,$vars);
		$c->detach('Base','eject_page',[$page]);
		return;
		$c->detach('Base','eject_page', [ $page ]);
	}
	if ( !check_transition($form,$vars) ) {
		$page = affiche_form($form,$vars);
		$c->detach('Base','eject_page', [ $page ]);
	}

	my $pid = $vars->{'pid'};
	my $payant = payant_par_id($pid);

	if ( ! defined $payant ) {
		$c->detach('Base','eject_error',["Cet item payant n'existe pas."]);
	}

        $page .= $self->small_table_1d($c,'payant',$payant,"Un item payant", {
                'Edition' => "/adsl/payant/new?id=$pid&from=payant$pid"
        });

	$c->detach('Base','eject_page', [ $page ]);
}

1;
